module.exports = grammar({
	name: "ini",

	extras: ($) => [$._comment, $._blank, /[\t ]/],

	rules: {
		document: ($) => seq(repeat($._blank), repeat($.section)),

		section: ($) => prec.left(seq($.section_name, repeat($.setting))),

		section_name: ($) =>
			seq("[", alias(/[^\[\]\n]+/, $.text), "]", choice("\n", "\r\n")),

		setting: ($) =>
			seq(
				alias(/[^;#=\s\[]+/, $.setting_name),
				"=",
				alias(/.*/, $.setting_value),
				choice("\n", "\r\n"),
			),

		_comment: ($) => seq(/[;#]/, /[^\n]*/, choice("\n", "\r\n")),

		_blank: () => /\r?\n/,
	},
});
